/* Copyright 2023 Yann ORLAREY
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <algorithm>
#include <functional>
#include <random>

#include "check.hh"
#include "interval_algebra.hh"
#include "interval_def.hh"

namespace itv {
//------------------------------------------------------------------------------------------
// Interval Mem
// interval Mem(const interval& x) const;
// void testMem() const;

interval interval_algebra::Mem(const interval& x) const
{
    if (x.isEmpty()) return {};
    return reunion(x, interval{0});
}

void interval_algebra::testMem() const
{
    check("test algebra Mem", Mem(interval(5)), interval(0, 5));
    check("test algebra Mem", Mem(interval(-1, 1)), interval(-1, 1));
}
}  // namespace itv
