/* Copyright 2023 Yann ORLAREY
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <algorithm>
#include <functional>
#include <random>

#include "check.hh"
#include "interval_algebra.hh"
#include "interval_def.hh"

namespace itv {
//------------------------------------------------------------------------------------------
// Interval Rsh
// interval Rsh(const interval& x, const interval& y) const;
// void testRsh() const;

interval interval_algebra::Rsh(const interval& x, const interval& y) const
{
    interval j{pow(2, -y.hi()), pow(2, -y.lo())};
    return Mul(x, j);
}

void interval_algebra::testRsh() const
{
    check("test algebra Rsh", Rsh(interval(8, 16), interval(4)), interval(0.5, 1));
}
}  // namespace itv
